/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "HW_Configs.h"

//   ------------------------------------------------------
extern uint32_t Xx;

//    ----------------------------------------

/////////////  ,    /////////////////////////
void SYS_Config(void)
{
	//    -----------------------------------------------------
#ifdef NODEBUG
	if (FLASH_OB_GetRDP() == RESET) //     
	{
		FLASH_OB_Unlock(); //  
		FLASH_OB_RDPConfig(OB_RDP_Level_1);
		FLASH_OB_Lock(); //  
	}
#endif  

	//   -----------------------------------------------------------
#ifdef W_DOG
	IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable); //     
	IWDG_SetPrescaler(IWDG_Prescaler_16); // 40 / 16 = 400 -  
	IWDG_SetReload(2500); // 0.4 * 2500 = 1  -  
	while(IWDG_GetFlagStatus(IWDG_FLAG_RVU) != RESET) {} //  
	IWDG_ReloadCounter(); //  
	IWDG_Enable(); //     LSI
#endif  
}


/////////////   /////////////////////////////////////////////
void SCK_Config(void)
{
	//  ----------------------------------------------------------------------
	RCC_DeInit(); //   " "
	RCC_HCLKConfig(RCC_SYSCLK_Div1); //   AHB
	RCC_PCLKConfig(RCC_HCLK_Div1); //    APB

#ifdef EXT_QUARZ //  
	RCC_HSEConfig(RCC_HSE_ON); //   
	if (RCC_WaitForHSEStartUp() == ERROR) //   
	{ //   -    
		RCC_HSEConfig(RCC_HSE_OFF); //   
		Delay_ms(120);
		NVIC_SystemReset();
	}
	else // 
	{
		RCC_ClockSecuritySystemCmd(ENABLE); //  CSS (  NMI)
		RCC_PREDIV1Config(RCC_PREDIV1_Div2); // 8MHz /2 (  /2  HSI)
		RCC_PLLConfig(RCC_PLLSource_PREDIV1, RCC_PLLMul_12); // PLLCLK = 8MHz /2 * 12 = 48 MHz
	}
#else //  
	RCC_PLLConfig(RCC_PLLSource_HSI_Div2, RCC_PLLMul_12); // PLLCLK = 8MHz /2 * 12 = 48 MHz
#endif

	RCC_PLLCmd(ENABLE); //  PLL
	while (RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET) {} //   PLL
	RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK); //  SYSCLK  PLL
	while (RCC_GetSYSCLKSource() != 0x08) {} //     PLL
	// --------------------------------------------------------------------------
	SystemCoreClockUpdate (); //  SystemCoreClock =  
}


///////////// Configures GPIO //////////////////////////////////////////
void GPIO_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStructure; //    

	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE); //     AHB
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE); //     AHB
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOF, ENABLE); //     AHB

	GPIO_DeInit(GPIOA); //   " "
	GPIO_DeInit(GPIOB); //   " "
	GPIO_DeInit(GPIOF); //   " "

	// SPI1
	GPIO_PinAFConfig(GPIOB, GPIO_PinSource3, GPIO_AF_0); //  
	GPIO_PinAFConfig(GPIOB, GPIO_PinSource5, GPIO_AF_0); //  
	GPIO_PinAFConfig(GPIOA, GPIO_PinSource15, GPIO_AF_0); //  
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3|GPIO_Pin_5; //   
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF; // 		
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; // 
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP; //   
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL; // 
	GPIO_Init(GPIOB, &GPIO_InitStructure); 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15; //   
	GPIO_Init(GPIOA, &GPIO_InitStructure); // 

	// COMP1_OUT
	GPIO_PinAFConfig(GPIOA, GPIO_PinSource6, GPIO_AF_7); //  
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6; //   
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF; // 
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP; //   
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL; // 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; // 
	GPIO_Init(GPIOA, &GPIO_InitStructure); // 

	// --> , DAC, COMP
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_4; //   
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN; // 
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL; // 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz; // 
	GPIO_Init(GPIOA, &GPIO_InitStructure); // 

	// --> 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3|GPIO_Pin_5|GPIO_Pin_7|GPIO_Pin_8|GPIO_Pin_9|GPIO_Pin_10|GPIO_Pin_11|GPIO_Pin_12; //   
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT; // 
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP; //   
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL; // 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz; // 
	GPIO_Init(GPIOA, &GPIO_InitStructure); // 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_4|GPIO_Pin_6|GPIO_Pin_7; //   
	GPIO_Init(GPIOB, &GPIO_InitStructure); // 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1; //   
	GPIO_Init(GPIOF, &GPIO_InitStructure); // 
}


///////////////////////////// Configures Comparators ///////////////////////////////////////////
void COMP_Config(void)
{
	COMP_InitTypeDef	COMP_InitStructure;
	EXTI_InitTypeDef EXTI_InitStructure; //     

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG, ENABLE);

	COMP_InitStructure.COMP_InvertingInput = COMP_InvertingInput_IO; // PA0
	COMP_InitStructure.COMP_Output = COMP_Output_None; //   PA6
	COMP_InitStructure.COMP_OutputPol = COMP_OutputPol_NonInverted;
	COMP_InitStructure.COMP_Hysteresis = COMP_Hysteresis_Low;
	COMP_InitStructure.COMP_Mode = COMP_Mode_HighSpeed;
	COMP_Init(COMP_Selection_COMP1, &COMP_InitStructure);
	COMP_Cmd(COMP_Selection_COMP1, ENABLE);

	// Configure EXTI line
	EXTI_InitStructure.EXTI_Line = EXTI_Line21; // COMP1
	EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
	EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising;
	EXTI_InitStructure.EXTI_LineCmd = ENABLE;
	EXTI_Init(&EXTI_InitStructure);
}


/////////////   /////////////////////
void DAC_Config(void)
{
	DAC_InitTypeDef DAC_InitStructure;

	DAC_DeInit(); //  
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_DAC, ENABLE);

	DAC_InitStructure.DAC_Trigger = DAC_Trigger_None;
	DAC_InitStructure.DAC_WaveGeneration = DAC_WaveGeneration_None;
	DAC_InitStructure.DAC_OutputBuffer = DAC_OutputBuffer_Enable; // 
	DAC_InitStructure.DAC_LFSRUnmask_TriangleAmplitude = DAC_TriangleAmplitude_15;
	DAC_Init(DAC_Channel_1, &DAC_InitStructure);

	DAC_DMACmd(DAC_Channel_1, ENABLE);
	DAC_Cmd(DAC_Channel_1, ENABLE);
	DAC->DHR12R1 = 2048; //  
}


///////////////////////////// Configures TIMER ///////////////////////////////////////////
void TIM_Config(void) // ---------------------------------------------
{ 
	TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure; //   

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1, ENABLE); //  
	TIM_DeInit(TIM1); //   " "

	TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1; // 0       ETR
	TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up; // 
	TIM_TimeBaseInitStructure.TIM_Period = 97 - 1; //   495k
	TIM_TimeBaseInitStructure.TIM_Prescaler = 0x0000; //    TIM_Prescaler+1,   1
	TIM_TimeBaseInitStructure.TIM_RepetitionCounter = 0x00; //   TIM1,    
	TIM_TimeBaseInit(TIM1, &TIM_TimeBaseInitStructure); // 

	TIM_SelectOutputTrigger(TIM1, TIM_TRGOSource_Update); //  
	TIM_Cmd(TIM1, ENABLE); // 
}


///////////////////////////// Configures ADC ///////////////////////////////////////////
void ADC_Config(void)
{
	ADC_InitTypeDef ADC_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, ENABLE); // 
	ADC_ClockModeConfig(ADC1, ADC_ClockMode_SynClkDiv4); //  48/4=12
//	ADC_ClockModeConfig(ADC1, ADC_ClockMode_AsynClk); //     14

	ADC_DeInit(ADC1); //   " "
	ADC_StructInit(&ADC_InitStructure);
	ADC_InitStructure.ADC_Resolution = ADC_Resolution_10b; // 
	ADC_InitStructure.ADC_ContinuousConvMode = DISABLE; //   CONT=1
	ADC_InitStructure.ADC_ExternalTrigConvEdge = ADC_ExternalTrigConvEdge_Rising; // 
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_T1_TRGO; //   
	ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right; // 
	ADC_InitStructure.ADC_ScanDirection = ADC_ScanDirection_Upward; //
	ADC_Init(ADC1, &ADC_InitStructure); 

	// ADC_SampleTime_7_5Cycles - f=667 12M 10b
	ADC_ChannelConfig(ADC1, ADC_Channel_2, ADC_SampleTime_7_5Cycles);

//	ADC_DiscModeCmd(ADC1, ENABLE); //  DISCEN=1 ?
	ADC_OverrunModeCmd(ADC1, ENABLE); //   
	ADC_GetCalibrationFactor(ADC1); // 

	ADC_DMARequestModeConfig(ADC1, ADC_DMAMode_Circular); // 
	ADC_DMACmd(ADC1, ENABLE); //  
	ADC_Cmd(ADC1, ENABLE); // 
	while(!ADC_GetFlagStatus(ADC1, ADC_FLAG_ADRDY)); // Wait the ADRDY flag
	ADC_StartOfConversion(ADC1); // 
	ADC_ITConfig(ADC1, ADC_IT_EOSEQ, ENABLE); //   
}


///////////////////////////// Configures SPI ///////////////////////////////////////////
void SPI_Config(void)
{
	SPI_InitTypeDef SPI_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1, ENABLE); // 
   
	SPI_I2S_DeInit(SPI1); //   " "

	SPI_StructInit(&SPI_InitStructure);
	SPI_InitStructure.SPI_Direction = SPI_Direction_1Line_Tx;
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master; // 
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_10b;
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low; //   
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge; //   
	SPI_InitStructure.SPI_NSS = SPI_NSS_Hard; //    - ( SSM)
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_8; // 6MHz
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB; //   - 
	SPI_InitStructure.SPI_CRCPolynomial = 7;
	SPI_Init(SPI1, &SPI_InitStructure);

	SPI_NSSPulseModeCmd(SPI1, ENABLE); //  ( NSSP)     
	SPI_SSOutputCmd(SPI1, ENABLE); // ( SSOE) NSS  (  )

	SPI_Cmd(SPI1, ENABLE); // 
}


/////////////    /////////////////////
void DMA_Config(void)
{
	DMA_InitTypeDef   DMA_InitStructure;

	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE); // Enable DMA1 clock

	DMA_DeInit(DMA1_Channel1); //   ADC
	DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)&ADC1->DR;
//	DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)&Xx;
	DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)&SPI1->DR;
	DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;
	DMA_InitStructure.DMA_BufferSize = 1;
	DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
	DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Disable;
	DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;
	DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;
	DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;
	DMA_InitStructure.DMA_Priority = DMA_Priority_Medium;
	DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;
	DMA_Init(DMA1_Channel1, &DMA_InitStructure);
	DMA_Cmd(DMA1_Channel1, ENABLE);
}


/////////////    /////////////////////
void NVIC_Config(void)
{
	NVIC_InitTypeDef NVIC_InitStructure; //     

	//    COMP1
	NVIC_InitStructure.NVIC_IRQChannel = ADC1_COMP_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPriority = 2;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);

	//      ( = 3,  )
	SysTick_Config(SystemCoreClock / 1000); // 1 mS
}

// -------------------------------------------------------------------------------------------------------



