/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "HW_Configs.h"
#include "stm32f0xx_it.h"

//   ------------------------------------------------------

//   -----------------------------------------------------------
uint32_t Xx = 0x05;


//    ----------------------------------------

////////////////////////////////   /////////////////////////////////////////
int main(void)
{
//-------------------------------------------------------------------------------------
//    startup_stm32f0xx.s. 
//	 stm32f0xx.h  -  ,   ,  .
//	 system_stm32f0xx.c :
//		SystemInit() -  HSI,  .
//		SetSysClock() -   HSE.   ?
//-------------------------------------------------------------------------------------

	SYS_Config(); // ,   
	SCK_Config(); // 
	GPIO_Config(); //  
	COMP_Config();
	DAC_Config();
	DMA_Config();
	SPI_Config(); // 
	ADC_Config();
	TIM_Config();
	NVIC_Config(); //   

	__enable_irq();



	while (1)
	{

		Delay_ms(200);


#ifdef W_DOG			//  
		IWDG_ReloadCounter(); //  
#endif
	}
}


////////////    //////////////////////////////////////////////
void Delay_ms(uint32_t ms)
{
	ms *= SystemCoreClock / 6000; //  Optimize Level2 + for Time
	while (ms-- != 0) {__asm(" nop");}
}


/////////////////////////////////////////////////////////////////////////////////
#ifdef  USE_FULL_ASSERT 
void assert_failed(uint8_t* file, uint32_t line){
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

	TFT_DrawString("ASSERT !!", 194, 70, 1, BRIGHTRED);

	while (1)  {  }
}
#endif
