#ifndef __MAIN_H /* Define to prevent recursive inclusion --------------------*/
#define __MAIN_H
#ifdef __cplusplus
 extern "C" {
#endif

//#define USE_FULL_ASSERT	// ,    

/* Main Includes ------------------------------------------------------------------*/
#include "stm32f0xx.h"
#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

//   -------------------------------------------------------------
#define _BITSET(bits) ((uint16_t)((bits % 010) | (bits / 010 % 010) << 1 | (bits / 0100 % 010) << 2 | \
  (bits / 01000 % 010) << 3 | (bits / 010000 % 010) << 4 | (bits / 0100000 % 010) << 5 | (bits / 01000000 % 010) << 6 | \
  (bits / 010000000 % 010) << 7 | (bits / 0100000000 % 010) << 8 | (bits / 01000000000 % 010) << 9 | (bits / 010000000000 % 010) << 10 | \
  (bits / 0100000000000 % 010) << 11 | (bits / 01000000000000 % 010) << 12 | (bits / 010000000000000 % 010) << 13 | \
  (bits / 0100000000000000 % 010) << 14 | (bits / 01000000000000000 % 010) << 15))
#define BIN(bits) _BITSET(0##bits)	// : BIN(111001100110)

#define BIT(n) (1UL<<(n))	// : BIT(2)|BIT(0) == 0b101 == 0x5
typedef enum {FALSE = 0, TRUE = !FALSE} bool;

//   -----------------------------------------------------
//#define EXT_QUARZ		//   
//#define NODEBUG			//    FLASH
//#define W_DOG			//  

// stm32f051k8
#define FLASH_PAGE_SIZE         ((uint32_t)0x00000400)   /* FLASH Page Size (1)*/
#define FLASH_USER_START_ADDR   ((uint32_t)0x0800FC00)   /* Start @ of user Flash area */
#define FLASH_USER_END_ADDR     ((uint32_t)0x08010000)   /* End @ of user Flash area */

//  ------------------------------------------------------------
#define	VER				1

#define	SYSCORECLOCK	48000000UL

#define	CLIPDELMS			80
#define	COMPDELMS			30

#define LCLIP_ON()		(GPIOB->BSRR = GPIO_Pin_1)
#define LCLIP_OFF()		(GPIOB->BRR = GPIO_Pin_1)

#define LTRIG_ON()		(GPIOB->BSRR = GPIO_Pin_7)
#define LTRIG_OFF()		(GPIOB->BRR = GPIO_Pin_7)

#define PIN_TEST1_GET()	(GPIOB->IDR & GPIO_Pin_15)
#define PIN_TEST1_ON()	(GPIOB->BSRR = GPIO_Pin_15)
#define PIN_TEST1_OFF()	(GPIOB->BRR = GPIO_Pin_15)
#define PIN_TEST1_TOG() (GPIOB->ODR ^= GPIO_Pin_15)
#define PIN_TEST1_OUT()	(GPIOB->MODER &= ~GPIO_MODER_MODER15_1)
#define PIN_TEST1_IN()	(GPIOB->MODER |= GPIO_MODER_MODER15)

 //  Optimize Level2 + for Time
#define DELAY_US(x)		{\
	uint32_t _dcnt;\
	_dcnt = x;\
	_dcnt *= SystemCoreClock / 8000000;\
	while (_dcnt-- != 0) {__asm(" nop");__asm(" nop");}}


//    ----------------------------------------
void Delay_ms(uint32_t ms);


#ifdef __cplusplus
}
#endif
#endif /* __MAIN_H */
