// 

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32f0xx_it.h"

//   ------------------------------------------------------

//   -----------------------------------------------------------
int32_t Cnt_Clip = 0;
int32_t Cnt_Comp = 0;


//   -----------------------------------------------------------

//    ----------------------------------------
void NMI_Handler(void);
void HardFault_Handler(void);
void SVC_Handler(void);
void PendSV_Handler(void);
void SysTick_Handler(void);

/******************************************************************************/
/*            Cortex-M0 Processor Exceptions Handlers                         */
/******************************************************************************/

/**
  * @brief  This function handles NMI exception.
  */
void NMI_Handler(void)
{
#ifdef EXT_QUARZ //  
	Delay_ms(120);
	NVIC_SystemReset();
#endif
}

/**
  * @brief  This function handles Hard Fault exception.
  */
void HardFault_Handler(void)
{
  /* Go to infinite loop when Hard Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles SVCall exception.
  */
void SVC_Handler(void)
{
}

/**
  * @brief  This function handles PendSVC exception.
  */
void PendSV_Handler(void)
{
}

/**
  * @brief  This function handles SysTick Handler.
  */
void SysTick_Handler(void) // 1
{

	if (Cnt_Clip != 0) //  
	{
		if (Cnt_Clip > CLIPDELMS) LCLIP_ON(); else LCLIP_OFF(); //    -  LED,  - 
		Cnt_Clip--;
	}

	if (Cnt_Comp != 0) //  
	{
		if (Cnt_Comp > COMPDELMS) LTRIG_ON(); else LTRIG_OFF(); //    -  LED,  - 
		Cnt_Comp--;
	}
	else //  
	{
		if ((COMP->CSR & COMP_CSR_COMP1OUT)!= 0) LTRIG_ON(); else LTRIG_OFF(); //  
	}
}


/******************************************************************************/
/*                 STM32F0xx Peripherals Interrupt Handlers                   */
/*  Add here the Interrupt Handler for the used peripheral(s) (PPP), for the  */
/*  available peripheral interrupt handler's name please refer to the startup */
/*  file (startup_stm32f0xx.s).                                               */
/******************************************************************************/
void ADC1_COMP_IRQHandler(void)
{

	if ((uint32_t)(ADC1->ISR & ADC_IT_EOSEQ) != (uint32_t)RESET) // 
	{
		if ((Cnt_Clip == 0)&&((ADC1->DR > 1013)||(ADC1->DR < 10))) Cnt_Clip = CLIPDELMS*2; //   ""  
		ADC1->ISR = ADC_IT_EOSEQ; //  
	}

	if ((uint32_t)(EXTI->PR & EXTI_Line21) != (uint32_t)RESET) //   0->1
	{
		if (Cnt_Comp == 0) Cnt_Comp = COMPDELMS*2; //      
		EXTI->PR = EXTI_Line21; //  
	}
}









